package org.openxma.dsl.generator.helper.style;

import java.util.Map;

import org.openxma.dsl.generator.helper.PresentationModelExtension;
import org.openxma.dsl.generator.helper.WidgetExtension;
import org.openxma.dsl.pom.model.ContentAlignment;
import org.openxma.dsl.pom.model.StylePropertyAlignment;
import org.openxma.dsl.pom.model.StyleSpecificationProperty;

import at.spardat.xma.guidesign.DataLabel;
import at.spardat.xma.guidesign.XMAButton;
import at.spardat.xma.guidesign.XMALabel;
import at.spardat.xma.guidesign.XMATableColumn;
import at.spardat.xma.guidesign.XMAText;
import at.spardat.xma.guidesign.types.AlignmentType;

public class ApplyAlignmentStyle {

    private static AlignmentType alignmentToSet(Map<Integer,StyleSpecificationProperty> styleProperties, ContentAlignment contentAlignment) {
        if (contentAlignment == null || contentAlignment == ContentAlignment.DEFAULT) {
            StylePropertyAlignment alignmentProperty = PresentationModelExtension.getAlignmentStyle(styleProperties);
            if (alignmentProperty != null) {
                return WidgetExtension.contentAlignment2AlignmentType(alignmentProperty.getAlignment());
            }
        } else {
            return WidgetExtension.contentAlignment2AlignmentType(contentAlignment);
        }
        return null;
    }

    public static void applyAlignment(XMAText xmaText, ContentAlignment contentAlignment, Map<Integer,StyleSpecificationProperty> styleProperties) {
        AlignmentType alignmentType = alignmentToSet(styleProperties, contentAlignment);
        if (alignmentType != null) {
            xmaText.setCodAlignment(alignmentType);
        }
    }

    public static void applyAlignment(XMAButton xmaButton, ContentAlignment contentAlignment, Map<Integer,StyleSpecificationProperty> styleProperties) {
        AlignmentType alignmentType = alignmentToSet(styleProperties, contentAlignment);
        if (alignmentType != null) {
            xmaButton.setCodAlignment(alignmentType);
        }
    }

    public static void applyAlignment(XMALabel xmaLabel, ContentAlignment contentAlignment, Map<Integer,StyleSpecificationProperty> styleProperties) {
        AlignmentType alignmentType = alignmentToSet(styleProperties, contentAlignment);
        if (alignmentType != null) {
            xmaLabel.setCodAlignment(alignmentType);
        }
    }

    public static void applyAlignment(DataLabel xmaLabel, ContentAlignment contentAlignment, Map<Integer,StyleSpecificationProperty> styleProperties) {
        AlignmentType alignmentType = alignmentToSet(styleProperties, contentAlignment);
        if (alignmentType != null) {
            xmaLabel.setCodAlignment(alignmentType);
        }
    }

    public static void applyAlignment(XMATableColumn xmaTableColumn, ContentAlignment contentAlignment, Map<Integer,StyleSpecificationProperty> styleProperties) {
        AlignmentType alignmentType = alignmentToSet(styleProperties, contentAlignment);
        if (alignmentType != null) {
            xmaTableColumn.setCodAlignment(alignmentType);
        }
    }

}
