package org.openxma.xmadsl.formatting;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;
import org.openxma.dsl.core.model.Model;
import org.openxma.dsl.core.model.ModelElement;
import org.openxma.dsl.dom.model.Attribute;
import org.openxma.dsl.dom.model.ComplexType;
import org.openxma.dsl.pom.naming.PomNameProvider;

public class DomainModelFormatting extends ModelFormatting {

	private static DomainModelFormatting instance;
	public static DomainModelFormatting getInstance() {
		if (instance == null) {
			instance = new DomainModelFormatting();
		}
		return instance;
	}

	@Override
	public ArrayList<String> formatModel(EObject obj) {

		if (obj == null || obj instanceof Model == false) {
			throw new IllegalArgumentException("Element to be formatted has to be an instance of Model: "+obj);
		}

		Model domainModel = (Model)obj;

        ArrayList<String> data = new ArrayList<String>();

        formatImports(domainModel,data);

    	Iterator<ModelElement> bdIt = domainModel.getElements().iterator();
    	while (bdIt.hasNext()) {
    		ModelElement domObject = bdIt.next();
    		if (domObject instanceof ComplexType) {
    			ComplexType complexType = (ComplexType)domObject;
	    		data.add("");
	    		data.add("Entity "+complexType.getName()+" {");

	    		for (int i=0;i<complexType.getAttributes().size();i++) {
	    			Attribute attr = complexType.getAttributes().get(i);
	    			String typeName = PomNameProvider.getXmaName(attr.getType().getDataType());
	        		data.add("");
	    			data.add(indent(1)+typeName+" "+attr.getName());
	    		}
	    		data.add("");
	    		data.add("}");
    		}
    	}
    	return data;
	}


}
